//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  PaleVioletRed
#property indicator_width1  2
#property indicator_level1  80
#property indicator_level2  20
#property indicator_levelcolor DarkGray
#property indicator_minimum 0
#property indicator_maximum 100

//
//
//
//
//

extern int RsiPeriod        = 14;
extern int RsiPrice         = PRICE_CLOSE;
extern int VolatilityPeriod =  5;
extern int VolatilitySmooth = 10;

double rsi[];
double price[];
double sum[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
      SetIndexBuffer(0,rsi);
      SetIndexBuffer(1,price);
      SetIndexBuffer(2,sum);
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int k,count,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
    
      for(int i = limit; i >= 0; i--)
      {
         price[i]   =  iMA(NULL,0,1,0,MODE_SMA,RsiPrice,i);
         sum[i]     =  0;      for (k = 0; k<VolatilityPeriod; k++) sum[i] += MathAbs(price[i+k]-price[i+k+1]);
         double avg =  sum[i]; for (k = 1; k<VolatilitySmooth; k++) avg    += sum[i+k];
                avg /= VolatilitySmooth;
         
                //
                //
                //
                //
                //
                
                if (avg!=0 && sum[i]!=0)
                     int rsiPer = MathFloor(MathMax(RsiPeriod/(sum[i]/avg),RsiPeriod/2));
                else     rsiPer = RsiPeriod;
                rsi[i] = iRSI(NULL,0,rsiPer,RsiPrice,i);
      }
   return(0);
}